---
schema_version: "1"
id: c29fcbf8aaecb0ae2256f7325c7733da20f1521d9d1da916b26ae1fadd1ece90
title: Shopper Customers
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/commerce-api/references/generated-api-specs/shopper-customers.md
canonical_url: https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-customers
source_site: developer.salesforce.com
content_type: documentation
content_hash: 8e748ad9775cec242b5eaf33791fc8d80e0765806a66b5293d43406252f72a77
products:
  - B2C Commerce API
  - Salesforce APIs
---
Shopper Customers

# Shopper Customers

[Download API specification](https://developer.salesforce.com/static/commercecloud/commerce-api/shopper-customers/shopper-customers-oas-v1-public.yaml)

## API Overview

The Shopper Customers API enables you to develop functionality that lets customers log in, and manage their profiles and product lists. Profile management includes ability for shoppers to add or modify addresses and payment methods, and add or modify products to wishlists or favorites. Commerce Cloud provides a rich set of Authentication APIs that include logging in guest shoppers, registered shoppers, agents on behalf of customers and a trusted system authentication on behalf of customers. In all authentication scenarios involving customers, a JSON Web Token (JWT) is generated in Commerce Cloud. Using the JWT, customers can access other Shopper API resources like Orders and Baskets. The application must refresh the JWT every 30 minutes to save the shopper activity (for example, retain products in a shopper's cart) for prolonged periods of time.

### Authentication & Authorization

The client requesting the customer information must have access to the Customer and Product List resources. The Shopper Customer API requires a shopper access token from the Shopper Login and API Access Service (SLAS).

You must include the relevant scope(s) in the client ID used to generate the SLAS token. For a full list of permissions, see the [Authorization Scopes Catalog.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/auth-z-scope-catalog.html)

For details on how to request a shopper access token from SLAS, see the guest user flows for [public clients](https://developer.salesforce.com/docs/commerce/commerce-api/guide/slas-public-client.html#guest-user) and [private clients](https://developer.salesforce.com/docs/commerce/commerce-api/guide/slas-private-client.html#guest-user) in the SLAS guides.

### Customization

#### Custom Properties

This API supports custom properties (prefixed with `c_`). For details, see [Custom Properties.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/custom-properties.html)

#### Hooks

For details on working with hooks, see [Extensibility with Hooks.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/extensibility_via_hooks.html)

### Response Details

#### Personalization

Responses from this API are not personalized via the Shopper Context API.

#### Caching

Responses from this API are not cached. Customer data is personal and unique to each shopper.

#### Timeouts

Shopper API requests must respond within 10 seconds, including any hook execution. If a response exceeds this threshold, an HTTP 504 status code is returned. For details, see [Timeouts and Limits.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/timeouts-limits.html)

#### Error Handling

Error responses follow the [RFC 7807](https://datatracker.ietf.org/doc/html/rfc7807) problem detail format. To trace errors, include a `correlation-id` header in your request — the response returns it as `x-correlation-id`. For details, see [HTTP Status Codes and Errors.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/error-response-codes.html)

### Use Cases

#### Get Customer Profile

Retrieve a registered customer profile. Requires a registered shopper SLAS token.

```sh
curl "https://{shortCode}.api.commercecloud.salesforce.com/customer/shopper-customers/v1/organizations/{organizationId}/customers/{customerId}?siteId=RefArch" \
  -H "Authorization: Bearer {access_token}"
```

#### Register a New Customer

In this use case, a customer who is browsing on a commerce shopping app built using B2C Commerce APIs would like to create a customer profile, so that they can track their order when logged in on the next visit.

The API flow is shown in the following diagram:

![b2c-commerce-shopper-customers-screenshot-1.png](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/b2c-commerce-shopper-customers-screenshot-1.png)

1.  The shopper opens the shopping app.
2.  Request an access token from SLAS. For details, see the guest user flows for [public clients](https://developer.salesforce.com/docs/commerce/commerce-api/guide/slas-public-client.html#guest-user) and [private clients](https://developer.salesforce.com/docs/commerce/commerce-api/guide/slas-private-client.html#guest-user) in the SLAS guides.
3.  The SLAS API responds with the shopper access token (JWT).
4.  The shopper adds a product to their basket.
5.  Use the Shopper Baskets API to create a basket. The shopper JWT from SLAS is supplied in the authorization header.
6.  Save the basket with a registered user customer ID (even though the shopper is still a guest). The shopper JWT from SLAS is supplied in the authorization header.
7.  The shopper creates a profile.
8.  Use the Shopper Customers API to register the customer.

#### Authenticate a Trusted System on Behalf of a Customer

In this cross-cloud use case, a Experience Cloud user places an order on Commerce Cloud from the Experience Cloud using the platform APIs. The Experience Cloud app is a trusted system that has a trusted relationship with Commerce Cloud using the OAuth client credentials grant against the Commerce Cloud Account Manager. The Experience Cloud user logs in with a redirect to Salesforce IDM and after successful login, the client application is able to call B2C Commerce APIs on behalf of the customer. Commerce Cloud returns a JWT for the Experience Cloud user and the Experience Cloud user is able to place orders on Commerce Cloud.

The API flow is shown in the following diagram:

![b2c-commerce-shopper-customers-screenshot-2.png](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/b2c-commerce-shopper-customers-screenshot-2.png)

#### Reset Customer Password

In this use case, a shopper who is browsing on a commerce shopping app, built using B2C Commerce APIs, requests to reset their password. The app verifies the shopper's credentials and returns a 404 if verification fails. Otherwise, when the shopper requests their password to be reset, the app first creates a password reset token using the shopper’s login ID, and an account manager token (obtained using the client credentials grant). After the app has the password reset token, the app can prompt the shopper for new password. Any app-level customization, such as sending a password reset email, can be done at this step. Finally, the app calls the reset endpoint to reset the customer’s password.

![b2c-commerce-shopper-customers-screenshot-3.png](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/b2c-commerce-shopper-customers-screenshot-3.png)

#### Update Shopper LoginId

In this use case, in order to update a shopper's loginId, the PATCH /customers/{customerId} call can be used starting B2C Commerce Cloud GA release 24.7. The new field in the request called `currentPassword` is mandatory and needs to match the shopper's existing password. If this field is not provided or does not match the existing shopper password when trying to update loginId, a HTTP 400 response will be returned. If the loginId field is not sent in the PATCH request body, the `currentPassword` field is not required. **Note:** After the `loginId` is updated, a new SLAS token must be fetched for the shopper for subsequent calls.

### Related APIs

*   [Customers (Admin)](https://developer.salesforce.com/docs/commerce/commerce-api/references/customers?meta=Summary) — Manage customer records, addresses, and credentials.

**Version:** 1.10.1

## Servers

*   `https://{shortCode}.api.commercecloud.salesforce.com/customer/shopper-customers/v1`
    *   `shortCode (default shortCode) An eight-character string assigned to a realm for routing purposes. See [Base URL and Request Formation.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html)`

## Security

*   `ShopperToken` (oauth2) ShopperToken authentication follows the authorization code grant flow, as defined by the OAuth 2.1 standard. Depending on the type of OAuth client (public or private), this authorization flow has further requirements. For a detailed description of the authorization flow, see the [SLAS overview](https://developer.salesforce.com/docs/commerce/commerce-api/references?meta=shopper-login:Summary). A shopper token allows you to access the Shopper API endpoints of both the Open Commerce API (OCAPI) and the B2C Commerce API. These endpoints can be used to build headless storefronts and other applications. The `ShopperToken` security scheme is a parent of other security schemes, such as `ShopperTokenTsob`. A Shopper API endpoint can require a specific child scheme (`ShopperTokenTsob`, for example) that cannot be accessed with a regular shopper token.
    *   OAuth flow clientCredentials (tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/token)
    *   Scope sfcc.shopper-customers.register: Shopper Customers Register scope READONLY
    *   Scope sfcc.shopper-myaccount.baskets: Shopper MyAccount Baskets scope READONLY
    *   Scope sfcc.shopper-myaccount.orders: Shopper MyAccount Orders scope READONLY
    *   Scope sfcc.shopper-myaccount.paymentinstruments.rw: Shopper MyAccount PaymentInstruments scope
    *   Scope sfcc.shopper-myaccount.productlists: Shopper MyAccount ProductLists scope READONLY
    *   Scope sfcc.shopper-myaccount.productlists.rw: Shopper MyAccount ProductLists scope
    *   Scope sfcc.shopper-productlists: Shopper ProductLists scope READONLY
    *   OAuth flow authorizationCode (authorizationUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/authorize, tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/token)
    *   Scope sfcc.shopper-customers.register: Shopper Customers Register scope READONLY
    *   Scope sfcc.shopper-myaccount.baskets: Shopper MyAccount Baskets scope READONLY
    *   Scope sfcc.shopper-myaccount.orders: Shopper MyAccount Orders scope READONLY
    *   Scope sfcc.shopper-myaccount.paymentinstruments.rw: Shopper MyAccount PaymentInstruments scope
    *   Scope sfcc.shopper-myaccount.productlists: Shopper MyAccount ProductLists scope READONLY
    *   Scope sfcc.shopper-myaccount.productlists.rw: Shopper MyAccount ProductLists scope
    *   Scope sfcc.shopper-productlists: Shopper ProductLists scope READONLY
*   `RegisteredShopperToken` (oauth2) `RegisteredShopperToken` is a child of the `ShopperToken` security scheme and restricts access to a **registered (authenticated) shopper**. Access is only granted to a shopper token that represents a registered shopper; a guest shopper token is rejected. Endpoints secured with `RegisteredShopperToken` operate on identity-bound resources of a registered shopper, such as their addresses, payment instruments, password, or saved product lists. Besides these endpoints that require this specific subtype, all other endpoints secured by the `ShopperToken` parent scheme can be accessed with a `RegisteredShopperToken`. To get a `RegisteredShopperToken`, the shopper must authenticate with SLAS (for example, through the authorization code flow or the [login endpoint](https://developer.salesforce.com/docs/commerce/commerce-api/references/auth?meta=authenticateCustomer)). For details, see the [SLAS overview](https://developer.salesforce.com/docs/commerce/commerce-api/references?meta=shopper-login:Summary).
    *   OAuth flow authorizationCode (authorizationUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/authorize, tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/token)
    *   Scope sfcc.shopper-customers.login: Shopper Customers Login scope READONLY
    *   Scope sfcc.shopper-myaccount: Shopper MyAccount scope READONLY
    *   Scope sfcc.shopper-myaccount.rw: Shopper MyAccount scope
    *   Scope sfcc.shopper-myaccount.addresses: Shopper MyAccount Addresses scope READONLY
    *   Scope sfcc.shopper-myaccount.addresses.rw: Shopper MyAccount Addresses scope
    *   Scope sfcc.shopper-myaccount.paymentinstruments: Shopper MyAccount PaymentInstruments scope READONLY
    *   Scope sfcc.shopper-myaccount.paymentinstruments.rw: Shopper MyAccount PaymentInstruments scope
*   `AmOAuth2` (oauth2) AccountManager OAuth 2.0 bearer token Authentication.
    *   OAuth flow clientCredentials (tokenUrl: https://account.demandware.com/dwsso/oauth2/access\_token)
    *   Scope sfcc.shopper-customers.login: Shopper Customers Login scope READONLY
    *   OAuth flow authorizationCode (authorizationUrl: https://account.demandware.com/dwsso/oauth2/authorize, tokenUrl: https://account.demandware.com/dwsso/oauth2/access\_token, refreshUrl: https://account.demandware.com/dwsso/oauth2/access\_token)
*   `ShopperClientContextToken` (oauth2) ShopperClientContextToken is a separate security scheme used to track and validate client context information. It is valid for Guest shoppers flows only using SLAS private clients. For registered shoppers, use existing ShopperToken flows. For authentication details, see the [SLAS overview](https://developer.salesforce.com/docs/commerce/commerce-api/references?meta=shopper-login:Summary). This token allows access to Shopper API endpoints for guest shoppers only.
    *   OAuth flow clientCredentials (tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/token?hint=client\_context)
    *   Scope sfcc.shopper-customers.register: Shopper Customers Register scope READONLY
    *   Scope sfcc.shopper-myaccount.baskets: Shopper MyAccount Baskets scope READONLY
    *   Scope sfcc.shopper-myaccount.orders: Shopper MyAccount Orders scope READONLY
    *   Scope sfcc.shopper-myaccount.paymentinstruments.rw: Shopper MyAccount PaymentInstruments scope
    *   Scope sfcc.shopper-myaccount.productlists: Shopper MyAccount ProductLists scope READONLY
    *   Scope sfcc.shopper-myaccount.productlists.rw: Shopper MyAccount ProductLists scope
    *   Scope sfcc.shopper-productlists: Shopper ProductLists scope READONLY

## Operations

### POST Register a new customer.

`POST /organizations/{organizationId}/customers`

Operation ID: `registerCustomer`. Security: ShopperToken (sfcc.shopper-customers.register, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-customers.register, sfcc.shopper-standard).

Mandatory data includes the credentials, profile last name, and email. This endpoint requires a guest JSON Web Token (JWT) from the [Shopper Login and API Access Service](https://developer.salesforce.com/docs/commerce/commerce-api/references/auth?meta=getAccessToken). The return type object for this endpoint is a common customer object shared by multiple Shopper Customer endpoints. In this case, all customer object details are returned, but attributes that are not included in the response, although they might be part of the customer object, are ignored. For example, although address information is included in the customer object, it is not displayed in the response for this endpoint and is ignored.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `CustomerRegistration`.

_Example: CustomerRegistrationBody_

```
{
  "password": "12345!aBcD",
  "customer": {
    "login": "jsmith",
    "email": "jsmith@test.com",
    "firstName": "John",
    "lastName": "Smith"
  }
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `Customer`.
    
    _Example: customerRegistrationResponse_
    
    ```
    {
      "authType": "registered",
      "crmContactId": "003xx000004WhKe",
      "creationDate": "2020-02-13T17:44:15.892Z",
      "customerId": "abkd9LhOWzAiAFubdEDChtkMHW",
      "customerNo": "00006002",
      "email": "jsmith@test.com",
      "emailVerified": false,
      "enabled": true,
      "firstName": "John",
      "hasPassword": true,
      "lastModified": "2020-02-13T17:44:15.898Z",
      "lastName": "Smith",
      "login": "jsmith"
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **401** In the case of type credentials, the username is unknown or the password does not match. In the case of type session, the session is no longer active or the dwsecuretoken value is invalid. In both cases, the customer is disabled or locked.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer401_
    
    ```
    {
      "title": "Authentication Failed",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/authentication-failed",
      "detail": "Customer authentication based on JohnSmith failed.",
      "credentialType": "JohnSmith"
    }
    ```
    

### POST Reset customer password after obtaining a reset token.

`POST /organizations/{organizationId}/customers/password/actions/reset`

Operation ID: `resetPassword`. Security: AmOAuth2 (sfcc.shopper-customers.login).

This is the second step in the reset customer password flow, in which a customer password is reset by providing new credentials along with a reset token. This call should be preceded by a call to the /create-reset-token endpoint.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `ResetPasswordRequest`.

_Example: ResetPasswordBody_

```
{
  "resetToken": "R1e2s3e4t5T6o7k8e9n0",
  "login": "janedoe@test.com",
  "newPassword": "p@assword2"
}
```

#### Responses

*   **204** Reset password successful. No Content.
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    

### POST Get reset password token.

`POST /organizations/{organizationId}/customers/password/actions/create-reset-token`

Operation ID: `getResetPasswordToken`. Security: AmOAuth2 (sfcc.shopper-customers.login).

This is the first step in the reset customer password flow, in which a password reset token is requested for future use to reset a customer password. This call should be followed by a call to the /reset endpoint.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `ResetPasswordTokenRequest`.

_Example: ResetPasswordTokenBody_

```
{
  "login": "janedoe@test.com"
}
```

#### Responses

*   **200** Reset password token generated and returned successfully.
    
    Media type: `application/json`. Schema: `ResetPasswordToken`.
    
    _Example: getResetPasswordTokenSuccess_
    
    ```
    {
      "login": "janedoe@test.com",
      "email": "janedoe@test.com",
      "resetToken": "R1e2s3e4t5T6o7k8e9n0",
      "expiresInMinutes": 30
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    

### GET Gets the new external profile for a customer. This endpoint only accepts a registered customer ShopperToken (JWT).

`GET /organizations/{organizationId}/customers/external-profile`

Operation ID: `getExternalProfile`. Security: AmOAuth2 (sfcc.shopper-customers.login).

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `externalId` (query, string, required) The External ID of the customer.  
    Minimum length: 1.
*   `authenticationProviderId` (query, string, required) The authentication Provider Id.  
    Minimum length: 1.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerExternalProfile`.
    
    _Example: getExternalProfileSuccess_
    
    ```
    {
      "authenticationProviderId": "Google",
      "firstName": "John",
      "lastName": "Doe",
      "customerId": "bfqcN48dn2y4EaV9Qj5bNpVJVj",
      "email": "testCustomer@test.com",
      "externalId": "testCustomer@test.com"
    }
    ```
    
*   **400** Customer ExternalId URL parameter is not valid.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: getExternalProfile400_
    
    ```
    {
      "title": "Invalid Customer External Profile",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer-external-profile",
      "detail": "The customer external profile is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: getExternalProfile404_
    
    ```
    {
      "title": "Not Found",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/not-found",
      "detail": "No customer with external profile with ID 'abfTWMDZOgi3JPzkHjv9IhmziI' could be found.",
      "externalId": "abfTWMDZOgi3JPzkHjv9IhmziI"
    }
    ```
    

### POST Register a new external profile for a customer. This endpoint accepts a guest customer ShopperToken (JWT) only.

`POST /organizations/{organizationId}/customers/external-profile`

Operation ID: `registerExternalProfile`. Security: ShopperToken (sfcc.shopper-customers.register, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-customers.register, sfcc.shopper-standard).

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `CustomerExtProfileRequest`.

_Example: ExternalProfileBody_

```
{
  "authenticationProviderId": "Google",
  "firstName": "John",
  "lastName": "Doe",
  "email": "testCustomer@test.com",
  "externalId": "testCustomer@test.com"
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerExternalProfile`.
    
    _Example registerExternalProfileSuccess: same as GET /organizations/{organizationId}/customers/external-profile 200 response._
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **401** In the case of type credentials, the username is unknown or the password does not match. In the case of type session, the session is no longer active or the dwsecuretoken value is invalid. In both cases, the customer is disabled or locked.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example registerCustomer401: same as POST /organizations/{organizationId}/customers 401 response._
    

### GET Get a customer and all existing addresses and payment instruments associated with the requested customer. This endpoint only accepts a registered customer ShopperToken (JWT).

`GET /organizations/{organizationId}/customers/{customerId}`

Operation ID: `getCustomer`. Security: RegisteredShopperToken (sfcc.shopper-myaccount, sfcc.shopper-myaccount.rw, sfcc.shopper-standard).

#### Parameters

*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `expand` (query, array of string, style: form, explode: false)
    
    Expands the response with additional customer data.
    
    *   addresses (Default)
    *   paymentinstruments (Default)
    *   paymentmethodreferences (Requires Salesforce Payments integration; ignored otherwise)
    *   none (Excludes all expansion data)
    
      
    Items: Allowed values: `none`, `addresses`, `paymentinstruments`, `paymentmethodreferences`.
    
    _Example_
    
    ```
    [
      "addresses",
      "paymentinstruments",
      "paymentmethodreferences"
    ]
    ```
    
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `Customer`.
    
    _Example: getCustomerSuccess_
    
    ```
    {
      "addresses": [
        {
          "address1": "10 Presidential Way",
          "addressId": "me",
          "city": "Woburn",
          "countryCode": "US",
          "firstName": "John",
          "fullName": "John M. Smith",
          "lastName": "Smith",
          "postalCode": "01827",
          "salutation": "Mr.",
          "stateCode": "MA"
        }
      ],
      "authType": "registered",
      "crmContactId": "003xx000004WhKe",
      "creationDate": "2020-02-14T20:39:53.818Z",
      "customerId": "abfTEMDZOgi3JPrkHjv9IhoziM",
      "customerNo": "00010009",
      "email": "jsmith@demandware.com",
      "emailVerified": true,
      "firstName": "John",
      "gender": 1,
      "hasPassword": true,
      "lastName": "Smith",
      "paymentInstruments": [
        {
          "bankRoutingNumber": "0763564",
          "creationDate": "2017-08-20T11:30:36.000Z",
          "lastModified": "2017-08-20T11:30:50.000Z",
          "maskedGiftCertificateCode": "***********ode",
          "paymentCard": {
            "cardType": "Visa",
            "creditCardExpired": false,
            "expirationMonth": 2,
            "expirationYear": 2022,
            "holder": "John Smith",
            "maskedNumber": "***********ber2",
            "numberLastDigits": "ber2"
          },
          "paymentInstrumentId": "beybQiWcyatEEaaadniwhKxxFl",
          "paymentMethodId": "CREDIT_CARD"
        }
      ],
      "phoneBusiness": "234560003",
      "phoneHome": "123450003",
      "phoneMobile": "345670003"
    }
    ```
    
    _Example: getCustomerSuccessWithSalesforcePayments_
    
    ```
    {
      "addresses": [
        {
          "address1": "10 Presidential Way",
          "addressId": "me",
          "city": "Woburn",
          "countryCode": "US",
          "firstName": "John",
          "fullName": "John M. Smith",
          "lastName": "Smith",
          "postalCode": "01827",
          "salutation": "Mr.",
          "stateCode": "MA"
        }
      ],
      "authType": "registered",
      "crmContactId": "003xx000004WhKe",
      "creationDate": "2020-02-14T20:39:53.818Z",
      "customerId": "abfTEMDZOgi3JPrkHjv9IhoziM",
      "customerNo": "00010009",
      "email": "jsmith@demandware.com",
      "firstName": "John",
      "gender": 1,
      "hasPassword": false,
      "lastName": "Smith",
      "paymentInstruments": [],
      "paymentMethodReferences": [
        {
          "type": "card",
          "id": "pm_card_1234567890",
          "brand": "visa",
          "last4": "4242",
          "expiryMonth": 12,
          "expiryYear": 2028,
          "accountId": "acct_1RegszI5I22eU0I3"
        },
        {
          "type": "sepa_debit",
          "id": "pm_sepa_debit_1234567890",
          "last4": "5678",
          "accountHolderName": "John Smith",
          "accountId": "acct_1RegszI5I22eU0I3"
        }
      ],
      "phoneBusiness": "234560003",
      "phoneHome": "123450003",
      "phoneMobile": "345670003"
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: getCustomer404_
    
    ```
    {
      "title": "Not Found",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/not-found",
      "detail": "No customer with ID 'abfTWMDZOgi3JPzkHjv9IhmziI' could be found.",
      "customerId": "abfTWMDZOgi3JPzkHjv9IhmziI"
    }
    ```
    

### PATCH Update a customer. This endpoint only accepts a registered customer ShopperToken (JWT).

`PATCH /organizations/{organizationId}/customers/{customerId}`

Operation ID: `updateCustomer`. Security: RegisteredShopperToken (sfcc.shopper-myaccount.rw, sfcc.shopper-standard).

#### Parameters

*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `Customer`.

_Example: UpdateCustomerBody_

```
{
  "customerNo": "00010009",
  "firstName": "John",
  "lastName": "Wild",
  "email": "jwild@yourstore.com",
  "fax": "+49 03641 78393 346"
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `Customer`.
    
    _Example: updateCustomerResponse_
    
    ```
    {
      "authType": "registered",
      "crmContactId": "003xx000004WhKe",
      "creationDate": "2020-02-14T20:39:53.818Z",
      "customerId": "abfTEMDZOgi3JPrkHjv9IhoziM",
      "customerNo": "00010009",
      "email": "jwild@yourstore.com",
      "emailVerified": true,
      "enabled": true,
      "fax": "+49 03641 78393 346",
      "firstName": "John",
      "hasPassword": true,
      "lastLoginTime": "2020-02-14T20:51:59.313Z",
      "lastModified": "2020-02-14T20:55:12.133Z",
      "lastName": "Wild",
      "lastVisitTime": "2020-02-14T20:51:59.313Z",
      "login": "f0a43dc2-692a-43bf-b008-e10918ea935d",
      "previousLoginTime": "2020-02-14T20:51:59.313Z",
      "previousVisitTime": "2020-02-14T20:51:59.313Z"
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### POST Create a new address with the given name for the customer. This endpoint only accepts a registered customer ShopperToken (JWT).

`POST /organizations/{organizationId}/customers/{customerId}/addresses`

Operation ID: `createCustomerAddress`. Security: RegisteredShopperToken (sfcc.shopper-myaccount.addresses.rw, sfcc.shopper-standard).

#### Parameters

*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `CustomerAddress`.

_Example: CustomerAddressBody_

```
{
  "addressId": "home_address",
  "address1": "5 Wall St",
  "address2": "24 Presidential Way",
  "city": "Burlington",
  "companyName": "Salesforce Commerce Cloud",
  "countryCode": "US",
  "firstName": "John",
  "jobTitle": "Developer",
  "lastName": "Murphy",
  "phone": "408-555-1212",
  "postalCode": "01805",
  "postBox": "12a",
  "preferred": false,
  "salutation": "Mr.",
  "secondName": "Jim",
  "stateCode": "MA",
  "title": "Dr."
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerAddress`.
    
    _Example: customerAddressResponse_
    
    ```
    {
      "addressId": "home_address",
      "address1": "5 Wall St",
      "address2": "24 Presidential Way",
      "city": "Burlington",
      "companyName": "Salesforce Commerce Cloud",
      "countryCode": "US",
      "creationDate": "2020-02-14T21:13:29.769Z",
      "firstName": "John",
      "fullName": "John Jim Murphy",
      "jobTitle": "Developer",
      "lastModified": "2020-02-14T21:13:29.770Z",
      "lastName": "Murphy",
      "phone": "408-555-1212",
      "postalCode": "01805",
      "postBox": "12a",
      "preferred": false,
      "salutation": "Mr.",
      "secondName": "Jim",
      "stateCode": "MA",
      "title": "Dr."
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### GET Retrieve a customer's address by address name. This endpoint only accepts a registered customer ShopperToken (JWT).

`GET /organizations/{organizationId}/customers/{customerId}/addresses/{addressName}`

Operation ID: `getCustomerAddress`. Security: RegisteredShopperToken (sfcc.shopper-myaccount.addresses, sfcc.shopper-myaccount.addresses.rw, sfcc.shopper-standard).

#### Parameters

*   `addressName` (path, string, required) The name of the address to update.  
    Minimum length: 1. Maximum length: 256.
*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerAddress`.
    
    _Example customerAddressResponse: same as POST /organizations/{organizationId}/customers/{customerId}/addresses 200 response._
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### DELETE Delete a customer's address by address name. This endpoint only accepts a registered customer ShopperToken (JWT).

`DELETE /organizations/{organizationId}/customers/{customerId}/addresses/{addressName}`

Operation ID: `removeCustomerAddress`. Security: RegisteredShopperToken (sfcc.shopper-myaccount.addresses.rw, sfcc.shopper-standard).

#### Parameters

*   `addressName` (path, string, required) The name of the address to update.  
    Minimum length: 1. Maximum length: 256.
*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **204** No content
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### PATCH Update a customer's address by address name. This endpoint only accepts a registered customer ShopperToken (JWT).

`PATCH /organizations/{organizationId}/customers/{customerId}/addresses/{addressName}`

Operation ID: `updateCustomerAddress`. Security: RegisteredShopperToken (sfcc.shopper-myaccount.addresses.rw, sfcc.shopper-standard).

#### Parameters

*   `addressName` (path, string, required) The name of the address to update.  
    Minimum length: 1. Maximum length: 256.
*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `CustomerAddress`.

_Example CustomerAddressResponseBody: same as POST /organizations/{organizationId}/customers/{customerId}/addresses 200 response._

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerAddress`.
    
    _Example customerAddressResponse: same as POST /organizations/{organizationId}/customers/{customerId}/addresses 200 response._
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### GET Get the baskets for a customer. This endpoint accepts a registered customer ShopperToken (JWT) or a guest customer ShopperToken.

`GET /organizations/{organizationId}/customers/{customerId}/baskets`

Operation ID: `getCustomerBaskets`. Security: ShopperToken (sfcc.shopper-myaccount.baskets, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-myaccount.baskets, sfcc.shopper-standard).

#### Parameters

*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `BasketsResult`.
    
    _Example: customerBasketsResult_
    
    ```
    {
      "baskets": [
        {
          "basketId": "bccO1aOjgEnuIaaadk7pYO2rFE",
          "adjustedMerchandizeTotalTax": 0,
          "adjustedShippingTotalTax": 0,
          "agentBasket": true,
          "billingAddress": {
            "address1": "10 Presidential Way",
            "city": "Woburn",
            "countryCode": "US",
            "firstName": "John",
            "fullName": "John M. Smith",
            "id": "abfTEMDZOgi3JPrkHjv9IhoziM",
            "lastName": "Smith",
            "phone": "123450003",
            "postalCode": "01827",
            "salutation": "Mr.",
            "stateCode": "MA"
          },
          "bonusDiscountLineItems": [
            {
              "bonusProducts": [
                {
                  "productDescription": "Bonus Product",
                  "productId": "34984327448",
                  "productName": "Extra Fluffy Bonus Product",
                  "title": "Bonus Product"
                }
              ],
              "couponCode": "BONUS",
              "id": "qhegj345ruhrfkj",
              "maxBonusItems": 1,
              "promotionId": "basds98295jsafi"
            }
          ],
          "channelType": "storefront",
          "couponItems": [
            {
              "code": "5634573",
              "couponItemId": "100-89038",
              "statusCode": "coupon_code_already_in_basket",
              "valid": true
            }
          ],
          "creationDate": "2019-09-05T17:12:56.670Z",
          "currency": "USD",
          "customerInfo": {
            "c_familyStatus": "string",
            "customerId": "abfTEMDZOgi3JPrkHjv9IhoziM",
            "customerName": "John Smith",
            "customerNo": "1000",
            "email": "jsmith@demandware.com"
          },
          "giftCertificateItems": [
            {
              "amount": 0,
              "giftCertificateItemId": "901",
              "message": "Preferred Customer",
              "recipientEmail": "jsmith@demandware.com",
              "recipientName": "John Smith",
              "senderName": "Jane Smith",
              "shipmentId": "678934jsadLHY5"
            }
          ],
          "inventoryReservationExpiry": "2019-09-05T17:12:56.670Z",
          "lastModified": "2019-09-05T17:12:56.670Z",
          "merchandizeTotalTax": 0,
          "orderPriceAdjustments": [
            {
              "appliedDiscount": {
                "amount": 0,
                "percentage": 0,
                "priceBookId": "asdfgh4567",
                "type": "percentage"
              },
              "couponCode": "2345-009",
              "createdBy": "System",
              "creationDate": "2019-09-05T17:12:56.670Z",
              "custom": true,
              "itemText": "string",
              "lastModified": "2019-09-05T17:12:56.670Z",
              "manual": true,
              "price": 0,
              "priceAdjustmentId": "324545673fgjghj",
              "promotionId": "1000-7654",
              "promotionLink": "link to promotion",
              "reasonCode": "PRICE_MATCH"
            }
          ],
          "orderTotal": 0,
          "paymentInstruments": [
            {
              "amount": 0,
              "authorizationStatus": {
                "code": "AUTH",
                "message": "Authorizing",
                "status": 0
              },
              "bankRoutingNumber": "string",
              "maskedGiftCertificateCode": "string",
              "paymentCard": {
                "cardType": "Visa",
                "creditCardExpired": false,
                "creditCardToken": "sadjklfajkgae",
                "expirationMonth": 12,
                "expirationYear": 2019,
                "holder": "John",
                "issueNumber": "389342643978",
                "maskedNumber": "**************53",
                "numberLastDigits": "8753",
                "validFromMonth": 4,
                "validFromYear": 2015
              },
              "paymentInstrumentId": "creditCard",
              "paymentMethodId": "credit"
            }
          ],
          "productItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "bonusDiscountLineItemId": "string",
              "bonusProductLineItem": true,
              "bundledProductItems": [
                {
                  "quantity": 10
                }
              ],
              "gift": true,
              "giftMessage": "string",
              "inventoryId": "string",
              "itemId": "string",
              "itemText": "string",
              "optionItems": [
                {
                  "adjustedTax": 0,
                  "basePrice": 110,
                  "bonusDiscountLineItemId": "dsklgladsjkq349857",
                  "bonusProductLineItem": true,
                  "bundledProductItems": [
                    {
                      "quantity": 10
                    }
                  ],
                  "gift": true,
                  "giftMessage": "Happy Birthday",
                  "inventoryId": "258963",
                  "itemId": "apple-ipod-classic",
                  "itemText": "Apple iPod Classic",
                  "optionId": "34526hjyuGGH56",
                  "optionItems": [
                    {
                      "optionId": "sdiughsdjkfgoqtuy",
                      "optionValueId": "1564897654"
                    }
                  ],
                  "optionValueId": "string",
                  "price": 0,
                  "priceAdjustments": [
                    {
                      "appliedDiscount": {
                        "amount": 0,
                        "percentage": 0,
                        "priceBookId": "34526hjyuGGH56",
                        "type": "percentage"
                      },
                      "couponCode": "109475",
                      "createdBy": "System",
                      "creationDate": "2019-09-05T17:12:56.670Z",
                      "custom": true,
                      "itemText": "",
                      "lastModified": "2019-09-05T17:12:56.670Z",
                      "manual": true,
                      "price": 0,
                      "priceAdjustmentId": "1597563",
                      "promotionId": "963852",
                      "promotionLink": "link to promotion",
                      "reasonCode": "PRICE_MATCH"
                    }
                  ],
                  "priceAfterItemDiscount": 0,
                  "priceAfterOrderDiscount": 0,
                  "productId": "apple-ipod-classic",
                  "productListItem": {
                    "id": "2345245e654utjSSDFfdhh",
                    "priority": 0,
                    "productDetailsLink": {
                      "productDescription": "apple-ipod-classic",
                      "productId": "apple-ipod-classic",
                      "productName": "Apple iPod Classic",
                      "title": "Apple iPod Classic Silver"
                    },
                    "productList": {
                      "description": "My Product List",
                      "name": "Electronics",
                      "public": true,
                      "title": "My Electronics Wish List",
                      "type": "wish_list"
                    },
                    "public": true,
                    "purchasedQuantity": 0,
                    "quantity": 0,
                    "type": "product"
                  },
                  "productName": "Apple iPod Classic",
                  "quantity": 0,
                  "shipmentId": "12345rdsghfjh",
                  "shippingItemId": "47568ghfhjgkg",
                  "tax": 0,
                  "taxBasis": 0,
                  "taxClassId": "STATE",
                  "taxRate": 0
                }
              ],
              "price": 0,
              "priceAdjustments": [
                {
                  "appliedDiscount": {
                    "amount": 0,
                    "percentage": 0,
                    "priceBookId": "string",
                    "type": "percentage"
                  },
                  "couponCode": "sadfghgjw4e56r7",
                  "createdBy": "System",
                  "creationDate": "2019-09-05T17:12:56.672Z",
                  "custom": true,
                  "itemText": "string",
                  "lastModified": "2019-09-05T17:12:56.672Z",
                  "manual": true,
                  "price": 0,
                  "priceAdjustmentId": "asdgfhg5463798453",
                  "promotionId": "100-7345",
                  "promotionLink": "Link to promotion",
                  "reasonCode": "PRICE_MATCH"
                }
              ],
              "priceAfterItemDiscount": 0,
              "priceAfterOrderDiscount": 0,
              "productId": "string",
              "productListItem": {
                "id": "string",
                "priority": 0,
                "productDetailsLink": {
                  "productDescription": "apple-ipod-classic",
                  "productId": "apple-ipod-classic",
                  "productName": "Apple iPod Classic",
                  "title": "Apple iPod Classic Silver"
                },
                "productList": {
                  "description": "My Product List",
                  "name": "Electronics",
                  "public": true,
                  "title": "My Electronics Wish List",
                  "type": "wish_list"
                },
                "public": true,
                "purchasedQuantity": 0,
                "quantity": 0,
                "type": "product"
              },
              "productName": "Apple iPod Classic",
              "quantity": 0,
              "shipmentId": "12345rdsghfjh",
              "shippingItemId": "47568ghfhjgkg",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "STATE",
              "taxRate": 0
            }
          ],
          "productSubTotal": 0,
          "productTotal": 0,
          "shipments": [
            {
              "adjustedMerchandizeTotalTax": 0,
              "adjustedShippingTotalTax": 0,
              "gift": true,
              "giftMessage": "Happy Birthday",
              "merchandizeTotalTax": 0,
              "productSubTotal": 0,
              "productTotal": 0,
              "shipmentId": "1200",
              "shipmentNo": "3",
              "shipmentTotal": 0,
              "shippingAddress": {
                "address1": "10 Presidential Way",
                "city": "string",
                "countryCode": "US",
                "firstName": "John",
                "fullName": "John M. Smith",
                "id": "abfTWMDZOgi3JPzkHjv9IhmziI",
                "lastName": "Smith",
                "phone": "123450003",
                "postalCode": "01827",
                "salutation": "Mr.",
                "stateCode": "MA"
              },
              "shippingMethod": {
                "c_storePickupEnabled": true,
                "description": "Ship using FEDEX",
                "externalShippingMethod": "FEDEX",
                "id": "1200",
                "name": "John Smith",
                "price": 0,
                "shippingPromotions": [
                  {
                    "calloutMsg": "Callout Message",
                    "promotionId": "123452768sdfgh",
                    "promotionName": "Special Promotion"
                  }
                ]
              },
              "shippingStatus": "not_shipped",
              "shippingTotal": 0,
              "shippingTotalTax": 0,
              "taxTotal": 0,
              "trackingNumber": "89e980-562489-54ifsdgj"
            }
          ],
          "shippingItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "itemId": "2345245e654utjSSDFfdhh",
              "itemText": "apple-iPod-classic",
              "price": 0,
              "priceAdjustments": [
                {
                  "appliedDiscount": {
                    "amount": 0,
                    "percentage": 0,
                    "priceBookId": "string",
                    "type": "percentage"
                  },
                  "couponCode": "sadfghgjw4e56r7",
                  "createdBy": "System",
                  "creationDate": "2019-09-05T17:12:56.672Z",
                  "custom": true,
                  "itemText": "string",
                  "lastModified": "2019-09-05T17:12:56.672Z",
                  "manual": true,
                  "price": 0,
                  "priceAdjustmentId": "asdgfhg5463798453",
                  "promotionId": "100-7345",
                  "promotionLink": "Link to promotion",
                  "reasonCode": "PRICE_MATCH"
                }
              ],
              "priceAfterItemDiscount": 0,
              "shipmentId": "asghdfjghwertyu",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "STATE",
              "taxRate": 0
            }
          ],
          "shippingTotal": 0,
          "shippingTotalTax": 0,
          "sourceCode": "",
          "taxTotal": 0,
          "taxation": "gross"
        }
      ],
      "total": 1
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### GET Return a page list of all the customer's orders. The default page size is 10. This endpoint accepts a registered customer ShopperToken (JWT) or a guest customer ShopperToken.

`GET /organizations/{organizationId}/customers/{customerId}/orders`

Operation ID: `getCustomerOrders`. Security: ShopperToken (sfcc.shopper-myaccount.orders, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-myaccount.orders, sfcc.shopper-standard).

#### Parameters

*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `crossSites` (query, boolean) The flag indicating whether all sites should be searched. This flag is ignored unless a valid User / Agent is present with a trusted agent on behalf (TAOB) token. Without a TAOB token, only the customer's orders placed on the site specified by siteId are returned.
*   `from` (query, string) The start date for the date range filter (ISO 8601 format).
*   `until` (query, string) The end date for the date range filter (ISO 8601 format).
*   `status` (query, string) Filter results by status.
*   `expand` (query, string) This parameter enhances the order result with extra data. By using `expand=oms`, all orders for the current customer are loaded directly from Salesforce Order Management (SOM). The system returns the retrieved SOM order data, along with any orders not yet transferred to SOM. If your instance is not integrated with SOM, the `expand=oms` command is disregarded.  
    Allowed values: `oms`. Example: `oms`.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `limit` (query, integer (int32)) Number of records to retrieve per request. Must be between 1 (minimum) and 50 (maximum). Defaults to 10.  
    Default: `10`. Minimum: 1. Maximum: 50.
*   `offset` (query, integer (int32)) Used to retrieve the results based on a particular resource offset.  
    Default: `0`. Minimum: 0.
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerOrderResult`.
    
    _Example: CustomersOrdersResult_
    
    ```
    {
      "limit": 1,
      "data": [
        {
          "adjustedMerchandizeTotalTax": 0,
          "adjustedShippingTotalTax": 0,
          "billingAddress": {
            "address1": "10 Presidential Way",
            "city": "Woburn",
            "countryCode": "US",
            "firstName": "John",
            "fullName": "John M. Smith",
            "id": "abfTEMDZOgi3JPrkHjv9IhoziM",
            "lastName": "Smith",
            "phone": "123450003",
            "postalCode": "01827",
            "salutation": "Mr.",
            "stateCode": "MA"
          },
          "bonusDiscountLineItems": [
            {
              "bonusProducts": [
                {
                  "productDescription": "Bonus Product",
                  "productId": "34984327448",
                  "productName": "Extra Fluffy Bonus Product",
                  "title": "Bonus Product"
                }
              ],
              "couponCode": "BONUS",
              "id": "qhegj345ruhrfkj",
              "maxBonusItems": 1,
              "promotionId": "basds98295jsafi"
            }
          ],
          "channelType": "storefront",
          "confirmationStatus": "not_confirmed",
          "couponItems": [
            {
              "code": "5634573",
              "couponItemId": "100-89038",
              "statusCode": "coupon_code_already_in_basket",
              "valid": true
            }
          ],
          "creationDate": "2019-09-05T17:12:56.670Z",
          "currency": "USD",
          "customerInfo": {
            "c_familyStatus": "string",
            "customerId": "abfTEMDZOgi3JPrkHjv9IhoziM",
            "customerName": "John Smith",
            "customerNo": "00010009",
            "email": "jsmith@demandware.com"
          },
          "exportStatus": "not_exported",
          "externalOrderStatus": "string",
          "giftCertificateItems": [
            {
              "amount": 0,
              "giftCertificateItemId": "901",
              "message": "Preferred Customer",
              "recipientEmail": "jsmith@demandware.com",
              "recipientName": "John Smith",
              "senderName": "Jane Smith",
              "shipmentId": "678934jsadLHY5"
            }
          ],
          "lastModified": "2019-09-05T17:12:56.670Z",
          "merchandizeTotalTax": 0,
          "orderPriceAdjustments": [
            {
              "appliedDiscount": {
                "amount": 0,
                "percentage": 0,
                "priceBookId": "asdfgh4567",
                "type": "percentage"
              },
              "couponCode": "2345-009",
              "createdBy": "System",
              "creationDate": "2019-09-05T17:12:56.670Z",
              "custom": true,
              "itemText": "string",
              "lastModified": "2019-09-05T17:12:56.670Z",
              "manual": true,
              "price": 0,
              "priceAdjustmentId": "324545673fgjghj",
              "promotionId": "1000-7654",
              "promotionLink": "link to promotion",
              "reasonCode": "PRICE_MATCH"
            }
          ],
          "orderTotal": 0,
          "paymentInstruments": [
            {
              "amount": 0,
              "authorizationStatus": {
                "code": "AUTH",
                "message": "Authorizing",
                "status": 0
              },
              "bankRoutingNumber": "string",
              "maskedGiftCertificateCode": "string",
              "paymentCard": {
                "cardType": "Visa",
                "creditCardExpired": false,
                "creditCardToken": "sadjklfajkgae",
                "expirationMonth": 12,
                "expirationYear": 2019,
                "holder": "John",
                "issueNumber": "389342643978",
                "maskedNumber": "**************53",
                "numberLastDigits": "8753",
                "validFromMonth": 4,
                "validFromYear": 2015
              },
              "paymentInstrumentId": "creditCard",
              "paymentMethodId": "credit"
            }
          ],
          "paymentStatus": "not_paid",
          "productItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "bonusDiscountLineItemId": "string",
              "bonusProductLineItem": true,
              "bundledProductItems": [
                {
                  "quantity": 10
                }
              ],
              "gift": true,
              "giftMessage": "string",
              "inventoryId": "string",
              "itemId": "string",
              "itemText": "string",
              "optionItems": [
                {
                  "adjustedTax": 0,
                  "basePrice": 110,
                  "bonusDiscountLineItemId": "dsklgladsjkq349857",
                  "bonusProductLineItem": true,
                  "bundledProductItems": [
                    {
                      "quantity": 10
                    }
                  ],
                  "gift": true,
                  "giftMessage": "Happy Birthday",
                  "inventoryId": "258963",
                  "itemId": "apple-ipod-classic",
                  "itemText": "Apple iPod Classic",
                  "optionId": "34526hjyuGGH56",
                  "optionItems": [
                    {
                      "optionId": "sdiughsdjkfgoqtuy",
                      "optionValueId": "1564897654"
                    }
                  ],
                  "optionValueId": "string",
                  "price": 0,
                  "priceAdjustments": [
                    {
                      "appliedDiscount": {
                        "amount": 0,
                        "percentage": 0,
                        "priceBookId": "34526hjyuGGH56",
                        "type": "percentage"
                      },
                      "couponCode": "109475",
                      "createdBy": "System",
                      "creationDate": "2019-09-05T17:12:56.670Z",
                      "custom": true,
                      "itemText": "",
                      "lastModified": "2019-09-05T17:12:56.670Z",
                      "manual": true,
                      "price": 0,
                      "priceAdjustmentId": "1597563",
                      "promotionId": "963852",
                      "promotionLink": "link to promotion",
                      "reasonCode": "PRICE_MATCH"
                    }
                  ],
                  "priceAfterItemDiscount": 0,
                  "priceAfterOrderDiscount": 0,
                  "productId": "apple-ipod-classic",
                  "productListItem": {
                    "id": "2345245e654utjSSDFfdhh",
                    "priority": 0,
                    "productDetailsLink": {
                      "productDescription": "apple-ipod-classic",
                      "productId": "apple-ipod-classic",
                      "productName": "Apple iPod Classic",
                      "title": "Apple iPod Classic Silver"
                    },
                    "productList": {
                      "description": "My Product List",
                      "name": "Electronics",
                      "public": true,
                      "title": "My Electronics Wish List",
                      "type": "wish_list"
                    },
                    "public": true,
                    "purchasedQuantity": 0,
                    "quantity": 0,
                    "type": "product"
                  },
                  "productName": "Apple iPod Classic",
                  "quantity": 0,
                  "shipmentId": "12345rdsghfjh",
                  "shippingItemId": "47568ghfhjgkg",
                  "tax": 0,
                  "taxBasis": 0,
                  "taxClassId": "STATE",
                  "taxRate": 0
                }
              ],
              "price": 0,
              "priceAdjustments": [
                {
                  "appliedDiscount": {
                    "amount": 0,
                    "percentage": 0,
                    "priceBookId": "string",
                    "type": "percentage"
                  },
                  "couponCode": "sadfghgjw4e56r7",
                  "createdBy": "System",
                  "creationDate": "2019-09-05T17:12:56.672Z",
                  "custom": true,
                  "itemText": "string",
                  "lastModified": "2019-09-05T17:12:56.672Z",
                  "manual": true,
                  "price": 0,
                  "priceAdjustmentId": "asdgfhg5463798453",
                  "promotionId": "100-7345",
                  "promotionLink": "Link to promotion",
                  "reasonCode": "PRICE_MATCH"
                }
              ],
              "priceAfterItemDiscount": 0,
              "priceAfterOrderDiscount": 0,
              "productId": "string",
              "productListItem": {
                "id": "string",
                "priority": 0,
                "productDetailsLink": {
                  "productDescription": "apple-ipod-classic",
                  "productId": "apple-ipod-classic",
                  "productName": "Apple iPod Classic",
                  "title": "Apple iPod Classic Silver"
                },
                "productList": {
                  "description": "My Product List",
                  "name": "Electronics",
                  "public": true,
                  "title": "My Electronics Wish List",
                  "type": "wish_list"
                },
                "public": true,
                "purchasedQuantity": 0,
                "quantity": 0,
                "type": "product"
              },
              "productName": "Apple iPod Classic",
              "quantity": 0,
              "shipmentId": "12345rdsghfjh",
              "shippingItemId": "47568ghfhjgkg",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "STATE",
              "taxRate": 0
            }
          ],
          "productSubTotal": 0,
          "productTotal": 0,
          "shipments": [
            {
              "adjustedMerchandizeTotalTax": 0,
              "adjustedShippingTotalTax": 0,
              "gift": true,
              "giftMessage": "Happy Birthday",
              "merchandizeTotalTax": 0,
              "productSubTotal": 0,
              "productTotal": 0,
              "shipmentId": "1200",
              "shipmentNo": "3",
              "shipmentTotal": 0,
              "shippingAddress": {
                "address1": "10 Presidential Way",
                "city": "string",
                "countryCode": "US",
                "firstName": "John",
                "fullName": "John M. Smith",
                "id": "abfTWMDZOgi3JPzkHjv9IhmziI",
                "lastName": "Smith",
                "phone": "123450003",
                "postalCode": "01827",
                "salutation": "Mr.",
                "stateCode": "MA"
              },
              "shippingMethod": {
                "c_storePickupEnabled": true,
                "description": "Ship using FEDEX",
                "externalShippingMethod": "FEDEX",
                "id": "1200",
                "name": "John Smith",
                "price": 0,
                "shippingPromotions": [
                  {
                    "calloutMsg": "Callout Message",
                    "link": "link to shipping promotions",
                    "promotionId": "123452768sdfgh",
                    "promotionName": "Special Promotion"
                  }
                ]
              },
              "shippingStatus": "not_shipped",
              "shippingTotal": 0,
              "shippingTotalTax": 0,
              "taxTotal": 0,
              "trackingNumber": "89e980-562489-54ifsdgj"
            }
          ],
          "shippingItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "itemId": "2345245e654utjSSDFfdhh",
              "itemText": "apple-iPod-classic",
              "price": 0,
              "priceAdjustments": [
                {
                  "appliedDiscount": {
                    "amount": 0,
                    "percentage": 0,
                    "priceBookId": "string",
                    "type": "percentage"
                  },
                  "couponCode": "sadfghgjw4e56r7",
                  "createdBy": "System",
                  "creationDate": "2019-09-05T17:12:56.672Z",
                  "custom": true,
                  "itemText": "string",
                  "lastModified": "2019-09-05T17:12:56.672Z",
                  "manual": true,
                  "price": 0,
                  "priceAdjustmentId": "asdgfhg5463798453",
                  "promotionId": "100-7345",
                  "promotionLink": "Link to promotion",
                  "reasonCode": "PRICE_MATCH"
                }
              ],
              "priceAfterItemDiscount": 0,
              "shipmentId": "asghdfjghwertyu",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "STATE",
              "taxRate": 0
            }
          ],
          "shippingStatus": "not_shipped",
          "shippingTotal": 0,
          "shippingTotalTax": 0,
          "sourceCode": "",
          "status": "created",
          "taxTotal": 0,
          "taxation": "gross"
        }
      ],
      "offset": 0,
      "total": 1
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### PUT Update a customer's password. This endpoint only accepts a registered customer ShopperToken (JWT).

`PUT /organizations/{organizationId}/customers/{customerId}/password`

Operation ID: `updateCustomerPassword`. Security: RegisteredShopperToken (sfcc.shopper-customers.login, sfcc.shopper-standard).

#### Parameters

*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `PasswordChangeRequest`.

_Example: UpdatePasswordBody_

```
{
  "currentPassword": "01dpass",
  "password": "newpass"
}
```

#### Responses

*   **204** No content
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### POST Add a payment instrument to the customer information. This endpoint only accepts a registered customer ShopperToken (JWT).

`POST /organizations/{organizationId}/customers/{customerId}/payment-instruments`

Operation ID: `createCustomerPaymentInstrument`. Security: RegisteredShopperToken (sfcc.shopper-myaccount.paymentinstruments.rw, sfcc.shopper-standard).

#### Parameters

*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `CustomerPaymentInstrumentRequest`.

_Example: CustomerPaymentInstrumentBody_

```
{
  "paymentCard": {
    "expirationYear": 2027,
    "expirationMonth": 7,
    "validFromMonth": 8,
    "validFromYear": 2007,
    "issueNumber": "i117",
    "number": "1234567",
    "holder": "John Smith",
    "cardType": "MasterCard"
  },
  "giftCertificateCode": "gift_code7",
  "paymentMethodId": "OCAPI_Payment_Simple",
  "bankRoutingNumber": "bankrouting3776",
  "default": true
}
```

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerPaymentInstrument`.
    
    _Example: getCustomerPaymentInstrumentSuccess_
    
    ```
    {
      "bankRoutingNumber": "bankrouting3776",
      "paymentCard": {
        "cardType": "MasterCard",
        "creditCardExpired": false,
        "expirationMonth": 7,
        "expirationYear": 2027,
        "holder": "John Smith",
        "issueNumber": "i117",
        "maskedNumber": "***4567",
        "numberLastDigits": "4567",
        "validFromMonth": 8,
        "validFromYear": 2007
      },
      "paymentMethodId": "OCAPI_Payment_Simple",
      "paymentInstrumentId": "cdOLciWbOsYl6aaadkwcsx9xHH",
      "default": false
    }
    ```
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### GET Retrieve a customer's payment instrument by its ID. This endpoint only accepts a registered customer ShopperToken (JWT).

`GET /organizations/{organizationId}/customers/{customerId}/payment-instruments/{paymentInstrumentId}`

Operation ID: `getCustomerPaymentInstrument`. Security: RegisteredShopperToken (sfcc.shopper-myaccount.paymentinstruments, sfcc.shopper-myaccount.paymentinstruments.rw, sfcc.shopper-standard).

#### Parameters

*   `paymentInstrumentId` (path, string, required) The ID of the payment instrument to be retrievedCustomer.  
    Minimum length: 1.
*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `CustomerPaymentInstrument`.
    
    _Example getCustomerPaymentInstrumentSuccess: same as POST /organizations/{organizationId}/customers/{customerId}/payment-instruments 200 response._
    
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### DELETE Delete a customer's payment instrument. This endpoint only accepts a registered customer ShopperToken (JWT).

`DELETE /organizations/{organizationId}/customers/{customerId}/payment-instruments/{paymentInstrumentId}`

Operation ID: `deleteCustomerPaymentInstrument`. Security: ShopperToken (sfcc.shopper-myaccount.paymentinstruments.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-myaccount.paymentinstruments.rw, sfcc.shopper-standard).

#### Parameters

*   `paymentInstrumentId` (path, string, required) The ID of the payment instrument to be retrievedCustomer.  
    Minimum length: 1.
*   `customerId` (path, string, required) The customer ID.  
    Minimum length: 1.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **204** No content
*   **400** CustomerId URL parameter does not match the verified customer represented by the JWT token.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: registerCustomer400_
    
    ```
    {
      "title": "Invalid Customer",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-customer",
      "detail": "The customer is invalid."
    }
    ```
    
*   **404** Requested resource not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getCustomer404: same as GET /organizations/{organizationId}/customers/{customerId} 404 response._
    

### PATCH Update a customer's payment instrument. This endpoint only accepts a registered customer ShopperToken (JWT).

`PATCH /organizations/{organizationId}/customers/{customerId}/payment-instruments/{paymentInstrumentId}`

[...]
